### A free/open-source library for quantitative finance

Public Member Functions
CDO Class Reference

collateralized debt obligation More...

`#include <ql/experimental/credit/cdo.hpp>`

Inheritance diagram for CDO:
[legend]

List of all members.

## Public Member Functions

CDO (Real attachment, Real detachment, const std::vector< Real > &nominals, const std::vector< Handle< DefaultProbabilityTermStructure > > &basket, const Handle< OneFactorCopula > &copula, bool protectionSeller, const Schedule &premiumSchedule, Rate premiumRate, const DayCounter &dayCounter, Rate recoveryRate, Rate upfrontPremiumRate, const Handle< YieldTermStructure > &yieldTS, Size nBuckets, const Period &integrationStep=Period(10, Years))

Real | nominal ()
Real | lgd ()
Real | attachment ()
Real | detachment ()
std::vector< Real > | nominals ()
Size | size ()
bool | isExpired () const
| returns whether the instrument might have value greater than zero.
Rate | fairPremium () const
Rate | premiumValue () const
Rate | protectionValue () const
Size | error () const

## Detailed Description

collateralized debt obligation

The instrument prices a mezzanine CDO tranche with loss given default between attachment point and detachment point .

For purchased protection, the instrument value is given by the difference of the protection value and premium value ,

The protection leg is priced as follows:

- Build the probability distribution for volume of defaults (before recovery) or Loss Given Default at times/dates (premium schedule times with intermediate steps)
- Determine the expected value of the protection payoff at each time where

- The protection value is then calculated as

  where is the discount factor at time/date

The premium is paid on the protected notional amount, initially This notional amount is reduced by the expected protection payments at times so that the premium value is calculated as

where is the premium rate, is the day count fraction between date/time and

The construction of the portfolio loss distribution is based on the probability bucketing algorithm described in

John Hull and Alan White, "Valuation of a CDO and nth to default CDS without Monte Carlo simulation", Journal of Derivatives 12, 2, 2004

The pricing algorithm allows for varying notional amounts and default termstructures of the underlyings.

Possible enhancements:
  Investigate and fix cases

## Constructor & Destructor Documentation

CDO | ( | Real | attachment,
|  | Real | detachment,
|  | const std::vector< Real > & | nominals,
|  | const std::vector< Handle< DefaultProbabilityTermStructure > > & | basket,
|  | const Handle< OneFactorCopula > & | copula,
|  | bool | protectionSeller,
|  | const Schedule & | premiumSchedule,
|  | Rate | premiumRate,
|  | const DayCounter & | dayCounter,
|  | Rate | recoveryRate,
|  | Rate | upfrontPremiumRate,
|  | const Handle< YieldTermStructure > & | yieldTS,
|  | Size | nBuckets,
|  | const Period & | integrationStep = `Period(10, Years)`
| ) |  |

Parameters:

  attachment | fraction of the LGD where protection starts
  detachment | fraction of the LGD where protection ends
  nominals | vector of basket nominal amounts
  basket | default basket represented by a vector of default term structures that allow computing single name default probabilities depending on time
  copula | one-factor copula
  protectionSeller | sold protection if set to true, purchased otherwise
  premiumSchedule | schedule for premium payments
  premiumRate | annual premium rate, e.g. 0.05 for 5% p.a.
  dayCounter | day count convention for the premium rate
  recoveryRate | recovery rate as a fraction
  upfrontPremiumRate | premium as a tranche notional fraction
  yieldTS | yield term structure handle
  nBuckets | number of distribution buckets
  integrationStep | time step for integrating over one premium period; if larger than premium period length, a single step is taken